SystemOrganization addCategory: #'Seaside-Tests-WebServices'!

WAXmlComponent subclass: #WACalledXmlComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-WebServices'!

!WACalledXmlComponent methodsFor: 'rendering' stamp: 'pmm 12/29/2010 16:55'!
renderContentOn: xml
	xml tag: 'response' with: [
		xml tag: 'head' with: [
			xml tag: 'operations' with: [
				xml tag: 'url' with: xml actionUrl.
				xml tag: 'operation' with: [
					| callback |
					xml tag: 'name' with: 'answer'.
					callback := xml callbacks store: (WAValueCallback on: [ :value |
						self answer: value ]).
					(xml tag: 'parameter')
					attributeAt: 'name' put: callback;
					attributeAt: 'hasValue' put: 'true';
					attributeAt: 'description' put: 'value to be answered' ] ] ].
		xml tag: 'body' with: 'called' ]! !

WAXmlComponent subclass: #WASampleXmlComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-WebServices'!

!WASampleXmlComponent class methodsFor: 'testing' stamp: 'pmm 12/28/2010 16:31'!
canBeRoot
	^ true! !

!WASampleXmlComponent class methodsFor: 'registering' stamp: 'pmm 12/28/2010 16:50'!
register
	WAXmlAdmin 
		register: self
		asApplicationAt: 'xml'! !

!WASampleXmlComponent methodsFor: 'actions' stamp: 'pmm 12/28/2010 17:20'!
action
	| value |
	value := self call: WACalledXmlComponent new.
	Transcript cr; show: value; cr! !

!WASampleXmlComponent methodsFor: 'rendering' stamp: 'pmm 12/29/2010 16:51'!
renderContentOn: xml
	xml tag: 'response' with: [
		xml tag: 'head' with: [
			xml tag: 'operations' with: [
				xml tag: 'url' with: xml actionUrl.
				xml tag: 'operation' with: [
					| callback |
					xml tag: 'name' with: 'transcript'.
					callback := xml callbacks store: (WAValueCallback on: [ :value |
						Transcript cr; show: value; cr ]).
					(xml tag: 'parameter')
						attributeAt: 'name' put: callback;
						attributeAt: 'hasValue' put: 'true';
						attributeAt: 'description' put: 'shown in Transcript' ].
				xml tag: 'operation' with: [
					| callback |
					xml tag: 'name' with: 'call'.
					callback := xml callbacks store: (WAActionCallback on: [
						self action ]).
				(xml tag: 'parameter')
					attributeAt: 'name' put: callback;
					attributeAt: 'hasValue' put: 'false' ] ] ].
		xml tag: 'body' with: 'first step' ] ! !
